/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*       lodscore.h:  header file for lm_bayes, lm_markers, lm_multiple   */
/*                          and soon, lm_twoqtl                           */
/*                    contains #includes for header files for             */
/*                        libraries used                                  */
/*                    and #defines, typedefs, variables and               */
/*                        function prototypes                             */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef LODSCORE_H
#define LODSCORE_H

#define DEFINE_DATA

#include "parsie.h"
#include "nghds.h"
#include "pedchk.h"
#include "msample.h"
#include "lsample.h"
#include "quantset.h"
#include "rans.h"
#include "traits.h"

#ifdef LM_BAYES
#include "lm_bayes.h"
#endif

#ifdef MARKERS
#include "quant.h"
#include "mulmsample.h"
#endif /* MARKERS */

#ifdef TWOQTL
#include "twoqtl.h"
#include "quant.h"
#endif /* TWOQTL */

#ifdef DMALLOC
#include <dmalloc.h>
#endif /* DMALLOC */

/**
 * @defgroup lodscore Lodscore programs.
 * @ingroup Programs
 * @{
 */

#if 0
struct _cleanup clean_auto[] = {
{"als ",    free_fnams},
{"als ",    freeChkPed},
{"als ",    freeKey},
{"als ",    free_auto},
{"als ",    free_ped},
{"al  ",    free_cmplists},
{"als ",    free_nghds},
{"als ",    free_xxgg},
{"al"  ,    free_allefrq},
{"al  ",    free_switches},
{"al"  ,    free_marek},
{"al"  ,    locus_peel_free},
{"al"  ,    free_allocate_loci},
{"al"  ,    free_gen_pen},
{"al"  ,    free_logprob},
{"al"  ,    free_msmpl},
{"al"  ,    free_traits},
{"als ",    free_dub},
{""    ,    NULL}} ;
#endif

struct _cleanup clean_auto[] = {
{""    ,    NULL}} ;

/** @} */

#endif /*LODSCORE_H*/
