/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*      parselods.h:  header file for Pars/proc_lods.c, proc_lodsf.c,         */
/*                    proc_vnext.c                                            */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef PARSELODS_H             
#define PARSELODS_H
#include "parsedrop.h"

/**
 * @addtogroup lodscore
 * @{
 */
                                        /*built by add_vprntmap():            */
struct vprntmap_node {                  /*Vprntmap_node:                      */
   int chrom_no;                        /*the chrom no. selected              */
   int no;                              /*the tloc no.                        */
   struct px_map * p_beg;               /*ptr to beginning trial map positions*/
   struct px_map * p_end;               /*ptr to ending trial map positions   */
   struct pi_map_list * p_intv;         /*ptr to list of pos for ea map intv  */
   struct ps_map_list * p_sintv;        /*ptr to list of pos for ea sel intv  */
                     };                 /*(including beginning and ending)    */
typedef struct vprntmap_node PRNTVMAP;
typedef PRNTVMAP * PRNTVMAP_PTR;
static PRNTVMAP_PTR first_vpmap[3] = {NULL, NULL, NULL};

                                        /*built by add_tloc_vext():           */
struct px_map {                         /*Px_map:                             */
   int no_pos;                          /*no. beginning or ending pos.        */
   double * p_dist;                     /*ptr to dists to and recomb fracts   */
   double * p_rf;                       /*with 1st or last marker             */
               };
typedef struct px_map PXMAP;
typedef PXMAP * PXMAP_PTR;

                                        /*built by add_tloc_vint():           */
struct pi_map_list {                    /*Pi_map_list:  for ea interval:      */
   int intv_no;                         /*map interval no.                    */
   int selectd;                         /*relative selected mark no. or 0     */
   int no_prop;                         /*no. proportions                     */
   double * p_prop;                     /*ptr to proportions                  */
   struct pi_map_list * p_next;         /*ptr to node for next interval       */
                    };
typedef struct pi_map_list PIMAP;
typedef PIMAP * PIMAP_PTR;

                                        /*built by sel_tloc_vpos():           */
struct ps_map_list {                    /*Ps_map_list:  for ea interval:      */
   int intv_no;                         /*selected interval no. (0 = beg)     */
   int sel_map_mark;                    /*marker no. (at start of interval)   */
   int no_pos;                          /*no. test positions in interval      */
   double * p_sdist;                    /*ptr to dists (from selected marker) */
   double * p_rf;                       /*ptr to recomb fracts                */
   double * p_locdist;                  /*ptr to dists from preced loc (M,T)  */
   int * p_star;                        /*ptr to flags for marker-derived pos */
                                        /*at start of ea intv +last pos (n+1) */
   struct ps_map_list * p_next;         /*ptr to node for next interval       */
                    };
typedef struct ps_map_list PSMAP;
typedef PSMAP * PSMAP_PTR;

int  find_tr_tloc_vmap  (void);
int  mak_tlocvprmap     (SIM_PTR, PRNTMAP_PTR, int);
int  test_lods_pars     (void);
int  test_lods_sel      (void);
int  test_ps_pr         (void); 
int  test_tloc_vext     (SIM_PTR);
int  test_tloc_vext_sx  (SIM_PTR);
int  test_tloc_vint     (SIM_PTR);
int  test_tloc_vint_sx  (SIM_PTR);
int  test_tloc_vmap     (SIM_PTR, int *);
int  test_vpos_rules    (void);
void alloc_intval       (void);
void alloc_sintl        (PSMAP_PTR);
void find_nxt_tl_vmap   (int);
void sel_vprntmap_tr    (PRNTVMAP_PTR, PRNTMAP_PTR);
void sel_tloc_vpos      (PRNTVMAP_PTR, PRNTMAP_PTR);
void add_tloc_vext      (PRNTVMAP_PTR, int);
void add_tloc_vint      (PRNTVMAP_PTR, PRNTMAP_PTR, int);
void mak_intval         (void);
void mak_recval         (void);
void mak_locpos         (void);
void prnt_vmap          (int, int);
void prnt_vtloc_freqs   (SIM_PTR);
void prnt_qtrait_pars   (SIM_PTR); 
void prnt_lods_pars     (void);
void sel_tloc_vpos      (PRNTVMAP_PTR, PRNTMAP_PTR);
PRNTVMAP_PTR add_vprntmap   (VMAP_PTR, int);
PSMAP_PTR    alloc_sintv    (int);
VMAP_PTR     nxt_tl_vmap  (int, SIM_PTR);
XMAP_PTR     nxt_tloc_vext  (int, PRNTVMAP_PTR, int);
IMAP_PTR     nxt_tloc_vint  (int, int, PRNTVMAP_PTR);

/** @} */
  
#endif  /*PARSELODS_H*/

