/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/**
 * @file   pedcomp.h
 * @author Myrna Jewett
 * @date   Wed Sep  4 22:24:24 2002
 *
 * @brief  header file for PedComp/ pedcheck and kin.
 *
 * Also includes header files for libraries used
 *
 * \$Id: pedcomp.h,v 1.9 2005-08-14 00:19:36 thompson Exp $
 */

#ifndef PEDCOMP_H
#define PEDCOMP_H

#define DEFINE_DATA

#include "parsie.h"
#include "pedchk.h"
#include "nghds.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif /* DMALLOC */

/**
 * @addtogroup PedComp PedComp programs.
 * @ingroup Programs
 * @{
 */

static struct _cleanup clean_check[] = {
{"pk",    free_fnams},
{"pk",    freeChkPed},
{"pk",    freeKey},
{" k",    free_cmplists},
{" k",    free_auto},
{" k",    free_ped},
{" k",    free_nghds},
{" k",    free_dub},
{""  ,    NULL}};

void  set_kinix (int);

/** @} */

#endif /*PEDCOMP_H*/

