/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*         polyem.h:  header file for PolyEM/ bivar, multivar,          */
/*                        univar and unibig                             */
/*                    #includes for library header files are here       */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef POLYEM_H
#define POLYEM_H

#define DEFINE_DATA

/**
 * @addtogroup polyem PolyEM programs
 *
 * Programs for segregation analysis using EM algorithm.
 *
 * @ingroup Programs
 * @{
 */

#include "parsie.h"
#include "pedchk.h"
#include "quantset.h"
#include "quant.h"
#ifdef PEELING
#include "peelie.h"
#endif  /*PEELING*/

#ifdef DMALLOC
#include <dmalloc.h>
#endif /* DMALLOC */

static struct _cleanup clean_poly[] = {
{"ugbmdpal",    free_fnams},
{"ugbmdpal",    freeChkPed},
{"ugbmdpal",    freeKey},
{""        ,    NULL}};

/** @} */

#endif  /*POLYEM_H*/

