/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

int use_lsmpl_setup (void)              /* use locus-by-locus samp for setup  */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (SmplSetup == SEQIMP)
         err_typ = ERR_SSU;
      SmplSetup = INDEP_LOC;
   }
   return err_typ;
}

int use_sqimp_setup (void)              /* use sequential imputatn for setup  */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (SmplSetup == INDEP_LOC)
         err_typ = ERR_SSU;
      SmplSetup = SEQIMP;
   }
   return err_typ;
}

int use_sqimp_realz (void)              /* use N sequential imputation realiz */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (j_par[0] < 0)
         err_typ = ERR_NSI;
      NSeqImp = j_par[0];
   }
   return err_typ;
}

int use_full_em (void)                  /* use full (regular) Em              */
{
   if (chk_stat ())
   {
      chk_repeat ();
      IPtEM = 0;
   }
   return err_typ;
}

int use_part_em (void)                  /* use partitioned em                 */
{
   if (chk_stat ())
   {
      chk_repeat ();
      IPtEM = Y;
   }
   return err_typ;
}

int use_hybrd_maxi (void)               /* use hybrid algor for maximization  */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (MaximAlgo != UNDEF)
         err_typ = ERA_MXA;
      MaximAlgo = HYBRID;
   }
   return err_typ;
}

int use_mcem_maxi (void)                /* use MCEM for maximization          */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (MaximAlgo != UNDEF)
         err_typ = ERA_MXA;
      MaximAlgo = MCEM;
   }
   return err_typ;
}

int map_tl_tst_no_ip (void)             /* map no default interval proportns  */
{                                       /* FIXME */
   if (chk_stat ())
   {
      chk_repeat ();
      vmap_opt.default_nt = FALSE;
   }
   return err_typ;
}

int map_tl_tst_no_ip_c (void)           /* map no default interval proportns  */
{                                       /* FIXME */
   if (chk_stat ())
   {
      chk_repeat ();
      vmap_opt.default_nt = FALSE;
   }
   return err_typ;
}

int map_tl_tst_no_xp (void)             /* map no default external positions  */
{                                       /* FIXME */
   if (chk_stat ())
   {
      chk_repeat ();
      vmap_opt.default_xt = FALSE;
   }
   return err_typ;
}

int map_tl_tst_no_xp_c (void)           /* map no default external positions  */
{                                       /* FIXME */
   if (chk_stat ())
   {
      chk_repeat ();
      vmap_opt.default_xt = FALSE;
   }
   return err_typ;
}
