/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/* miscellaneous functions used for lm_mks_new, lm_mul_new and lm_hap 
   are defined here */
/* several are moved to Stuff/Sample libraries:  EAT Aug 2006             */
/* imin() is removed; lm_multiple routines using it fixed.  EAT Feb 2007  */
#include <float.h>
#include <limits.h>
#include <stdlib.h>
#include "mulmsample.h"

/*********************************************************/
/* This function is first defined by Liping in Nov, 2004 */
/* purpose: calculate log(x+y) if log(x) and log(y) is known
   input: log(x), log(y)
   output: log(x+y)
*/
double logsum (double logx, double logy)
{
   double tempmax, temp;
   if (logx <= -DBL_MAX)
      return logy;
   else if (logy <= -DBL_MAX)
      return logx;
   else
   {
      tempmax = max (logx, logy);
      temp = log (exp (-fabs (logx - logy)) + 1) + tempmax;
      return temp;
   };

}

/*********************************************************/
/* This function is first defined by Liping in Nov, 2004 */
/* purpose: calculate the transition probability
   input: hidden variable vectors ss1[0...m-1], ss2[0...m-1] 
          and recombination prob p
   output: log of prob of (ss2|ss1)
*/

double probtrans (int *ss2, int *ss1, int m, double *rr, int *sx)
{
   int   i;
   double pp;

   pp = 1;
   for (i = 0; i < m; i++)
      if (ss2[i] == ss1[i])
         pp = pp * (1 - rr[sx[i]]);
      else
         pp = pp * rr[sx[i]];
   return pp;
}
