#include "mulmsample.h"
/* Global variables used in this function:
   n_compnts, pedsize, cmplist;

   global variables changed in this function:
   NMarrs, marr, indmarr, cmpmarr
*/

/* assign values to Nmarr, marr and indmarr */
void setup_marriage (void)
{
   int   c, i1, i2, record, wi, hi, nk, nkm;
   int   kk, kkm, nmr, nmc;
   /*
      int *temp;
    */

   Indices *indhead, *indcurr, *indfrst, *indlast;
   Marrglist *marhead, *marcurr, *marlast;

   Indlist *pind, *pk;
   Marlist *pm;
   Component *pc;

   cmpmarr = malloc (n_compnts * sizeof (Marrg));
   alloc_chk (WHERE, cmpmarr);
   indmarr = malloc (pedsize * sizeof (IndMarrg));
   alloc_chk (WHERE, indmarr);

   marhead = malloc (sizeof (Marrglist));
   alloc_chk (WHERE, marhead);
   marhead->current = NULL;
   marhead->next = NULL;

   indhead = malloc (sizeof (Indices));
   alloc_chk (WHERE, indhead);
   indhead->index = -1;
   indhead->next = NULL;

   NMarrs = 0;
   marlast = marhead;
   indlast = indfrst = indhead;
   for (c = 0, pc = cmplist + 1; c < n_compnts; c++, pc++)
   {
      nmc = 0;                          /* number of marriages in component c */
      cmpmarr[c].c = c + 1;

      /*
         printf("\n component = %d", c+1); getchar();
       */

      pind = pc->people->next;          /* pointer to indidual in component c */
      while (pind)
      {
         i1 = pind->current->index;
         indmarr[i1].index = i1;
         indmarr[i1].c = c + 1;

         nmr = 0;                       /* number of marriages for individual i1 */
         /* in the case of Global MCMC, all the meioses are considered; 
            otherwise, consider only the large component */
         if (GlobalMcmc || (pc->nmeioses > MAXNMexact))
         {
            pm = pind->current->marriages; /* pointer to marriages of i1 */
            while (pm)                  /* i1 has marriages */
            {
               nmr++;

               indlast->next = malloc (sizeof (Indices));
               alloc_chk (WHERE, indlast->next);
               indlast = indlast->next;

               /* i2 is the index of spouse */
               i2 = pm->current->spouse->index;

               /*
                  printf("\n spouse = %s", nghd[i2].self); getchar();
                */

               /* check if this marriage is already recorded */
               record = 1;              /* 0: already in list of marhead; 1 : new marriage */
               marcurr = marhead->next;
               while (marcurr)
               {
                  wi = marcurr->current->wife;
                  hi = marcurr->current->husb;
                  if (wi == i1 && hi == i2)
                  {
                     record = 0;
                     break;
                  }
                  else if (wi == i2 && hi == i1)
                  {
                     record = 0;
                     break;
                  }
                  marcurr = marcurr->next;
               }

               /*
                  if (record == 0)
                  printf("\n old marriage");
                  else
                  printf("\n new marriage");
                  getchar();
                */

               if (record == 0)         /* old marriage */
                  indlast->index = marcurr->current->index;
               else                     /* new marriage */
               {
                  indlast->index = NMarrs;
                  nmc++;

                  marlast->next = malloc (sizeof (Marrglist));
                  alloc_chk (WHERE, marlast->next);
                  marlast = marlast->next;
                  marlast->current = malloc (sizeof (Marrg));
                  alloc_chk (WHERE, marlast->current);

                  /*
                     al_int_vector (&temp, 1);
                     printf("\n address of temp = %p", temp); getchar();
                   */

                  marlast->current->index = NMarrs;
                  marlast->current->c = c + 1;
                  NMarrs++;
                  if (nghd[i1].sex == 2) /* i1 is a female */
                  {
                     marlast->current->wife = i1;
                     marlast->current->husb = i2;
                  }
                  else                  /* i1 is a male */
                  {
                     marlast->current->wife = i2;
                     marlast->current->husb = i1;
                  }

                  /*
                     al_int_vector (&temp, 1);
                     printf("\n address of temp = %p", temp); getchar();
                   */

                  /* find nkid and nkidmeio */
                  nk = nkm = 0;         /* no. of kids and kid meioses */
                  pk = pm->current->kids; /* pointer to kids in current marriage */
                  while (pk)
                  {
                     nk++;
                     if (pk->current->matmeio > 0)
                        nkm++;
                     if (pk->current->patmeio > 0)
                        nkm++;

                     pk = pk->next;
                  }
                  marlast->current->nkid = nk;
                  marlast->current->nkidmeio = nkm;

                  /*
                     printf("\n no. of kid = %d, no. of kid meioses = %d", nk, nkm); getchar();
                   */

                  /* assign values to kid and kidmeio */
                  marlast->current->kid = NULL;
                  marlast->current->kidmeio = NULL;
                  if (nk)
                  {
                     al_int_vector (&(marlast->current->kid), nk);
                     al_int_vector (&(marlast->current->kidmeio), nkm);

                     pk = pm->current->kids;
                     kk = kkm = 0;
                     while (pk)
                     {
                        marlast->current->kid[kk++] = pk->current->index;
                        if (pk->current->matmeio > 0)
                           marlast->current->kidmeio[kkm++] =
                              pk->current->matmeio;
                        if (pk->current->patmeio > 0)
                           marlast->current->kidmeio[kkm++] =
                              pk->current->patmeio;
                        pk = pk->next;
                     }                  /* end of while (pk) */

                  }                     /* end of if (nk) */

               }                        /* end of if (record == 0) {} else {} */

               pm = pm->next;
            }                           /* end of while (pm) */
         }
         indlast->next = NULL;
         marlast->next = NULL;

         /*
            printf("\n No. of marriages = %d", nmr); getchar();
          */

         /* assign values to indmarr[i1].marr */
         indmarr[i1].nmarr = nmr;
         indmarr[i1].marr = NULL;
         if (nmr)
         {
            al_int_vector (&(indmarr[i1].marr), nmr);

            indcurr = indfrst->next;
            kk = 0;
            while (indcurr)
            {
               indmarr[i1].marr[kk] = indcurr->index;
               indcurr = indcurr->next;
               kk++;
            }
         }

         indfrst = indlast;
         pind = pind->next;
      }                                 /* end of while (pind) */

      indlast->next = NULL;
      marlast->next = NULL;

      cmpmarr[c].nmarr = nmc;
   }                                    /* end of for (c = 0;...) */

   indlast->next = NULL;
   marlast->next = NULL;

   /* assign values to marr */
   marr = NULL;
   if (NMarrs > 0)
   {
      marr = malloc (NMarrs * sizeof (Marrg));
      kk = 0;
      marlast = marhead->next;
      while (marlast)
      {
         marr[kk++] = *(marlast->current);
         marlast = marlast->next;
      }
   }

   /* assign values to cmpmarr[c].marr */
   nk = 0;
   for (c = 0; c < n_compnts; c++)
   {
      nmr = cmpmarr[c].nmarr;
      cmpmarr[c].marr = NULL;
      if (nmr)
      {
         al_int_vector (&(cmpmarr[c].marr), nmr);
         for (kk = 0; kk < nmr; kk++)
            cmpmarr[c].marr[kk] = nk++;
      }
   }

   /* free the chain start with indhead */
   while (indhead)
   {
      indcurr = indhead->next;
      free (indhead);
      indhead = indcurr;
   }

   /* free the chain start with marhead */
   while (marhead)
   {
      free (marhead->current);
      marcurr = marhead->next;
      free (marhead);
      marhead = marcurr;
   }

   return;
}

void prnt_marriage (void)
{
   int   c, k, t;
   int   mi;                            /* marriage indices */

   /* print cmpmarr and marr */
   for (c = 0; c < n_compnts; c++)
   {
      if (cmpmarr[c].nmarr > 0)
      {
         printf ("\n For Component %2d \n", cmpmarr[c].c);
         printf ("\n Number of marriages = %2d \n", cmpmarr[c].nmarr);
         for (k = 0; k < cmpmarr[c].nmarr; k++)
         {
            mi = cmpmarr[c].marr[k];
            printf ("\n For the %2d th marriage:", marr[mi].index + 1);
            printf ("\n wife = %s, husb = %s, nkid = %2d, nkidmeio = %2d",
                    nghd[marr[mi].wife].self, nghd[marr[mi].husb].self,
                    marr[mi].nkid, marr[mi].nkidmeio);
            printf ("\n Kids list:\n");
            for (t = 0; t < marr[mi].nkid; t++)
               printf (" %s", nghd[marr[mi].kid[t]].self);
            printf ("\n Kids' meioses list:\n");
            for (t = 0; t < marr[mi].nkidmeio; t++)
               printf (" %d", marr[mi].kidmeio[t]);
            printf ("\n");
         }
      }
   }

#if 0
   /* print indmarr */
   for (k = 0; k < pedsize; k++)
   {
      printf ("\n\n For individual %s", nghd[indmarr[k].index].self);
      if (indmarr[k].nmarr > 0)
      {
         printf ("\n Number of marriages = %2d", indmarr[k].nmarr);
         printf ("\n Marriages list:\n");
         for (t = 0; t < indmarr[k].nmarr; t++)
            printf (" %d", indmarr[k].marr[t]);
         printf ("\n");
      }
   }
#endif

   printf ("\n === Setup for marrige structure completed === \n\n\n");

   return;
}

void free_marriage (void)
{
   int   k;

   if (marr)
   {
      for (k = 0; k < NMarrs; k++)
      {
         if (marr[k].kid)
            free_1d ((void *) &(marr[k].kid));
         if (marr[k].kidmeio)
            free_1d ((void *) &(marr[k].kidmeio));
      }
      free (marr);
      marr = NULL;
   }
   if (indmarr)
   {
      for (k = 0; k < pedsize; k++)
      {
         if (indmarr[k].marr)
            free_1d ((void *) &(indmarr[k].marr));
      }
      free (indmarr);
      indmarr = NULL;
   }
   if (cmpmarr)
   {
      for (k = 0; k < n_compnts; k++)
      {
         if (cmpmarr[k].marr)
            free_1d ((void *) &(cmpmarr[k].marr));
      }
      free (cmpmarr);
      cmpmarr = NULL;
   }
   return;
}
