/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "lsample.h"
#include "msample.h"

/**
 * Sets up data structures for locus sampling.
 */
void setSampling (void)
{
   double mu;                           /* global mean */

   /* allocate arrays xx0, xx1, for meiosis indicators                   
    *                                        int xx0 [NMarks+1][PedSize]
    *                                            xx1 [NMarks+1][PedSize]  
    * allocate arrays gg0, gg1 for genes                                 
    *                                            gg0 [NMarks+1][PedSize]  
    *                                            gg1 [NMarks+1][PedSize]  */
   alloc_xxgg (NMarks, PedSize);

   /* allocate Locus structure                         
    *                                        struct Locus loci[NMarks+1]  */
   if (TraitTyp == QUANTITATIVE)
      allocate_loci (NMarks + 1, NAll, Qq, 4);
   else if (PedDatTyp == DISCR_LIAB)
      allocate_loci (NMarks + 1, NAll, Qq, 3);
   else if (PedDatTyp == DISCR_COVAR)
      allocate_loci (NMarks + 1, NAll, Qq, 5);
   else
      allocate_loci (NMarks + 1, NAll, Qq, 1);

   /* NOTE: trait values for quantitative trait are no longer centered
    *  EAT 8/2004   */
   /* set quantitative trait locus model
    *                                        loci[NMarks+1].* parameters  */
   if (TraitTyp == QUANTITATIVE)
      mu = set_quant_trait (NMarks);

   return;
}

/**
 * Sets up data structures for meiosis sampling.
 */
void setMSampling (void)
{
   /* allocate working arrays used by do_msmpl().
    * (for inheritance indicators, penetrance probabilities at each locus
    * and cumulative peeling probabilities along chromosome)
    */
   alloc_msmpl ();

   return;
}
